<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            
                <label for="messages">Messages:</label>
                <input type="messages" id="messages" name="messages" enterkeyhint="messages" value="*">
                <button type="button" id="searchBtn">messages!</button>
                <button type="button" id="allBtn">Show all</button>
                <label for="recipient">Recipient:</label>
                <input type="text" id="recipient" name="recipient" value="">
                
                <button type="button" id="sendBtn">Send</button>
                <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">

                <span></span>
                <label for="message">Message:</label>
                <textarea id="message" style="grid-row: span 4;">A message...</textarea>

                <form action="/logout"><input type="submit" value="Logout" />
                <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                </form>            
        </div>
        <div id="anchor"></div>
    </div>
</body>

<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('messages');
    var recipientField = document.getElementById('recipient');
    var messageField = document.getElementById('message');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var messages = async (query) => {
        const id = reqId++;
        const q = `/messages?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (recipient, message) => {
        const id = reqId++;
        const q = `/send?recipient=${encodeURIComponent(recipient)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });
    searchBtn.addEventListener('click', () => messages(searchField.value));
    allBtn.addEventListener('click', () => messages('*'));
    sendBtn.addEventListener('click', () => send(recipientField.value, messageField.value));
    checkAnnouncements();
</script>

</html>